
import java.util.*;
import java.io.*;

public class hopscotch_font
{
   public static void main(String[] args) throws Exception
   {
      PrintWriter out = new PrintWriter(System.out);
      new hopscotch_font(new FastScanner(System.in), out);
      out.close();
   }

   public hopscotch_font(FastScanner in, PrintWriter out)
   {
      int N = in.nextInt();
      int K = in.nextInt();
      long oo = Long.MAX_VALUE/3;
      long[][] cost = new long[N][N];
      for (long[] gg : cost)
         Arrays.fill(gg, oo);
      int[][] grid = new int[N][N];
      for (int i=0; i<N; i++)
         for (int j=0; j<N; j++)
         {
            grid[i][j] = in.nextInt();
            if (grid[i][j] == 1)
               cost[i][j] = 0;
         }


      boolean didUpdate = true;
      while (didUpdate)
      {
         didUpdate = false;

         for (int i=0; i<N; i++)
         {
            for (int j=0; j<N; j++) if (cost[i][j] < oo)
            {
               for (int x=0; x<N; x++)
               {
                  for (int y=0; y<N; y++)
                  {
                     if (grid[i][j]+1 == grid[x][y])
                     {
                        long cc = Math.abs(i-x)+Math.abs(j-y);
                        cc += cost[i][j];
                        if (cc < cost[x][y])
                        {
                           cost[x][y] = cc;
                           didUpdate = true;
                        }
                     }
                  }
               }
            }
         }
      }

      long res = oo;
      for (int i=0; i<N; i++)
         for (int j=0; j<N; j++)
            if (grid[i][j] == K)
               res = Math.min(res, cost[i][j]);

      out.println(res == oo ? -1 : res);
   }
}

class FastScanner
{
   private InputStream stream;
   private byte[] buf = new byte[1024];
   private int curChar;
   private int numChars;
    
   public FastScanner(InputStream stream)
   {
      this.stream = stream;
   }
    
   int read()
   {
      if (numChars == -1)
         throw new InputMismatchException();
      if (curChar >= numChars)
      {
         curChar = 0;
         try
         {
            numChars = stream.read(buf);
         } 
         catch (IOException e) 
         {
            throw new InputMismatchException();
         }
         
         if (numChars <= 0)
            return -1;
      }
      return buf[curChar++];
   }
    
   boolean isSpaceChar(int c)
   {
      return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
   }
   
   boolean isEndline(int c)
   {
      return c=='\n'||c=='\r'||c==-1;
   }
   
   int nextInt()
   {
      return Integer.parseInt(next());
   }
   
   long nextLong()
   {
      return Long.parseLong(next());
   }
   
   double nextDouble()
   {
      return Double.parseDouble(next());
   }
   
   String next()
   {
      int c = read();
      while (isSpaceChar(c))
         c = read();
      StringBuilder res = new StringBuilder();
      do
      {
         res.appendCodePoint(c);
         c = read();
      } while(!isSpaceChar(c));
      return res.toString();
   }
   
   String nextLine()
   {
      int c = read();
      while (isEndline(c))
         c = read();
      
      StringBuilder res = new StringBuilder();
      do
      {
         res.appendCodePoint(c);
         c = read();
      } while(!isEndline(c));
      return res.toString();
   }
}
